﻿using System;
using System.Globalization;

namespace Issue13126.Converters
{
    public class InvertBoolConverter : ToBoolConverter
    {
        public override object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return !((bool)base.Convert(value, targetType, parameter, culture));
        }

        public override object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value is bool)
                value = !((bool)value);
            return base.Convert(value, targetType, parameter, culture);
        }
    }
}
