﻿using System;
using System.Collections.ObjectModel;
using System.Windows.Input;
using System.Threading.Tasks;
using Xamarin.Forms;
using XamarinUniversity.Infrastructure;

using Issue13126.Models;

namespace Issue13126.ViewModels
{
    public class MyViewModel : ObservableObject
    {
        public MyViewModel()
        {
            this.LoadDataCommand = new Command(async () =>
            {
                this.IsBusy = true;
                try
                {
                    await Task.Delay(1000);

                    var loadedModels = new MyModel[20];
                    for (var i = 0; i < loadedModels.Length; i++)
                        loadedModels[i] = new MyModel($"Element number {i+1}");

                    using (this.Models.BeginMassUpdate())
                    {
                        this.Models.Clear();
                        this.Models.AddRange(loadedModels);
                    }
                }
                finally
                {
                    this.IsBusy = false;
                }
            },
            () => !this.IsBusy);
        }

        public ICommand LoadDataCommand { get; }

        public OptimizedObservableCollection<MyModel> Models { get; } = new OptimizedObservableCollection<MyModel>();
    }
}
